--the basics!
local L = AceLibrary("AceLocale-2.2"):new("Voyeur")
Voyeur = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0")

Voyeur.version = tonumber(string.sub("$Rev: 26998 $", 12, -3))
-- Voyeur.version = "r" .. Voyeur.revision
Voyeur.date = string.sub("$Date: 2007-02-02 16:12:30 -0500 (Fri, 02 Feb 2007) $", 8, 17)

BINDING_HEADER_VOYEUR = L["Voyeur"]
BINDING_NAME_VOYEUR = L["Inspect Target"]

local inspectCache = {}

function Voyeur:OnInitialize()
--	Voyeur:RegisterChatCommand({"/voyeur"}, options) -- Hold on to this for possible future use.

	InspectFrame_LoadUI()
	InspectFrame_OnUpdate = Voyeur_InspectFrame_OnUpdate

	InspectFrame:SetMovable(true) -- Make the Inspect Frame movable.
	InspectFrame:SetScript("OnMouseDown", function() this:StartMoving() end)
	InspectFrame:SetScript("OnMouseUp", function() this:StopMovingOrSizing() end)
	
	InspectFrame_Show = Voyeur_InspectFrame_Show
	InspectFrame_UnitChanged = Voyeur_InspectFrame_UnitChanged
	InspectFrame_OnShow = Voyeur_InspectFrame_OnShow
	InspectFrame_OnEvent = Voyeur_InspectFrame_OnEvent
	InspectPaperDollFrame_OnShow = Voyeur_InspectPaperDollFrame_OnShow
	InspectPaperDollItemSlotButton_Update = Voyeur_InspectPaperDollItemSlotButton_Update

	InspectPaperDollItemSlotButton_OnClick = Voyeur_InspectPaperDollItemSlotButton_OnClick

	InspectHeadSlot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectNeckSlot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectShoulderSlot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectBackSlot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectChestSlot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectShirtSlot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectTabardSlot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectWristSlot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectHandsSlot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectWaistSlot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectLegsSlot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectFeetSlot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectFinger0Slot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectFinger1Slot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectTrinket0Slot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectTrinket1Slot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectMainHandSlot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectSecondaryHandSlot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)
	InspectRangedSlot:SetScript("OnEnter", function() Voyeur_InspectPaperDollItemSlotButton_OnEnter() end)

-- Prevent the Player Menu inspect function from greying out beyond inspect distance
	UnitPopupButtons["INSPECT"] = { text = TEXT(INSPECT), dist = 0 }
end
-- Let's look at the other faction, even though we can't determine their gear.
function Voyeur_InspectFrame_Show(unit)
	HideUIPanel(InspectFrame)
	if (UnitExists(unit) and UnitIsPlayer(unit)) then
		NotifyInspect(unit)
		InspectFrame.unit = unit
		if CanInspect(unit) or InspectFrame.player ~= UnitName(unit) then
			InspectFrame.player = UnitName(unit)
			inspectCache = {}
			for i=1,19 do
				inspectCache[i] = GetInventoryItemLink(unit,i)
			end
		end
		ShowUIPanel(InspectFrame)
		InspectNameText:SetWidth(300)
		InspectNameText:SetText(UnitPVPName(unit))
		local guildname, guildtitle, guildrank = GetGuildInfo(unit)
		if(guildname ~= nil and guildtitle ~= nil and guildrank ~= nil) then
			InspectTitleText:SetText(format(TEXT(GUILD_TITLE_TEMPLATE), guildtitle, guildname))
			InspectTitleText:Show()
		else
			InspectTitleText:Hide()
		end
	end
end

function VoyeurInspect()
	if(InspectFrame:IsVisible()) then
		HideUIPanel(InspectFrame)
	else
		if UnitExists("target") then
			InspectUnit("target")
		elseif InspectFrame.player then
			ShowUIPanel(InspectFrame)
		end
	end
end

function Voyeur_InspectFrame_OnEvent(event)
	if not InspectFrame:IsVisible() then
		return
	end -- not sure why this should care about Party member changes.  Leaving this commented out for now.
--	if ( event == "PLAYER_TARGET_CHANGED" or event == "PARTY_MEMBERS_CHANGED" ) then
--		if ( (event == "PLAYER_TARGET_CHANGED" and this.unit == "target") or
--		     (event == "PARTY_MEMBERS_CHANGED" and this.unit ~= "target") ) then
	if ( event == "PLAYER_TARGET_CHANGED" ) then
		if ( (event == "PLAYER_TARGET_CHANGED" and InspectFrame.unit == "target") ) then
			if(UnitExists(unit) and UnitIsPlayer(unit)) then
				Voyeur_InspectFrame_UnitChanged()
--			else
--				HideUIPanel(InspectFrame)
			end
		end
		return
	elseif ( event == "UNIT_PORTRAIT_UPDATE" ) then
		if ( arg1 == InspectFrame.unit ) then
			SetPortraitTexture(InspectFramePortrait, arg1)
		end
		return
	elseif ( event == "UNIT_NAME_UPDATE" ) then
		if ( arg1 == InspectFrame.unit ) then
			local guildname, guildtitle, guildrank = GetGuildInfo(arg1)
			InspectNameText:SetText(UnitName(arg1))
		end
		return
	end
end

function Voyeur_InspectFrame_UnitChanged()
	local unit = InspectFrame.unit
	NotifyInspect(unit)
	SetPortraitTexture(InspectFramePortrait, unit)
	if CanInspect(unit) or InspectFrame.player ~= UnitName(unit) then
		InspectFrame.player = UnitName(unit)
		inspectCache = {}
		for i=1,19 do
			inspectCache[i] = GetInventoryItemLink(unit,i)
		end
	end
	InspectPaperDollFrame_OnShow()
	InspectNameText:SetWidth(300)
	InspectNameText:SetText(UnitPVPName(unit))
	local guildname, guildtitle, guildrank = GetGuildInfo(unit)
	if(guildname ~= nil and guildtitle ~= nil and guildrank ~= nil) then
		InspectTitleText:SetText(format(TEXT(GUILD_TITLE_TEMPLATE), guildtitle, guildname))
		InspectTitleText:Show()
	else
		InspectTitleText:Hide()
	end
end

function Voyeur_InspectFrame_OnUpdate()
	if UnitExists(InspectFrame.unit) and CanInspect(InspectFrame.unit) then
		Voyeur_InspectFrame_UnitChanged()
	end
end

function Voyeur_InspectPaperDollFrame_OnShow()
	local unit = InspectFrame.unit
	if not UnitExists(unit) then return end
	InspectModelFrame:SetUnit(unit)
	InspectPaperDollFrame_SetLevel()
	InspectPaperDollItemSlotButton_Update(InspectHeadSlot)
	InspectPaperDollItemSlotButton_Update(InspectNeckSlot)
	InspectPaperDollItemSlotButton_Update(InspectShoulderSlot)
	InspectPaperDollItemSlotButton_Update(InspectBackSlot)
	InspectPaperDollItemSlotButton_Update(InspectChestSlot)
	InspectPaperDollItemSlotButton_Update(InspectShirtSlot)
	InspectPaperDollItemSlotButton_Update(InspectTabardSlot)
	InspectPaperDollItemSlotButton_Update(InspectWristSlot)
	InspectPaperDollItemSlotButton_Update(InspectHandsSlot)
	InspectPaperDollItemSlotButton_Update(InspectWaistSlot)
	InspectPaperDollItemSlotButton_Update(InspectLegsSlot)
	InspectPaperDollItemSlotButton_Update(InspectFeetSlot)
	InspectPaperDollItemSlotButton_Update(InspectFinger0Slot)
	InspectPaperDollItemSlotButton_Update(InspectFinger1Slot)
	InspectPaperDollItemSlotButton_Update(InspectTrinket0Slot)
	InspectPaperDollItemSlotButton_Update(InspectTrinket1Slot)
	InspectPaperDollItemSlotButton_Update(InspectMainHandSlot)
	InspectPaperDollItemSlotButton_Update(InspectSecondaryHandSlot)
	InspectPaperDollItemSlotButton_Update(InspectRangedSlot)
end

function Voyeur_InspectPaperDollItemSlotButton_Update(button)
	local unit = InspectFrame.unit
	local itemString = Voyeur:GetInspectItemLink(button:GetID())
	local _, _, _, _, _, _, _, _, _, textureName = GetItemInfo(itemString or "")
	if textureName then
		SetItemButtonTexture(button, textureName)
		button.hasItem = 1
	else
		local textureName = button.backgroundTextureName
		if ( button.checkRelic and UnitHasRelicSlot(unit) ) then
			textureName = "Interface\\Paperdoll\\UI-PaperDoll-Slot-Relic.blp"
		end
		SetItemButtonTexture(button, textureName)
		SetItemButtonCount(button, 0)
		button.hasItem = nil
	end
end

function Voyeur_InspectFrame_OnShow()
	local unit = InspectFrame.unit
	if not UnitExists(unit) then return end
	PlaySound("igCharacterInfoOpen")
	SetPortraitTexture(InspectFramePortrait, unit)
	InspectNameText:SetText(UnitName(unit))
end

function Voyeur_InspectPaperDollItemSlotButton_OnClick(button)
	if IsControlKeyDown() then
		DressUpItemLink(Voyeur:GetInspectItemLink(this:GetID()))
	elseif IsShiftKeyDown() then
		ChatEdit_InsertLink(Voyeur:GetInspectItemLink(this:GetID()))
	end
end

function Voyeur_InspectPaperDollItemSlotButton_OnEnter()
	local itemString = Voyeur:GetInspectItemLink(this:GetID())
	GameTooltip:SetOwner(this, "ANCHOR_RIGHT")
	if itemString then
		GameTooltip:SetHyperlink(itemString)
	else
		local text = getglobal(strupper(strsub(this:GetName(), 8)))
		if (this.checkRelic and UnitHasRelicSlot(InspectFrame.unit)) then
			text = getglobal("RELICSLOT")
		end
		GameTooltip:SetText(text)
	end
	CursorUpdate()
end

function Voyeur:GetInspectItemLink(id)
	if not id or type(id) ~= "number" then return end
	return inspectCache[id]
end